.386
.model flat,syscall
option casemap:none

include \masm32\include\windows.inc
include Paint.imp
include invoke.inc

includelib kernel32.lib
includelib user32.lib

.data
ClassName db "SimpleWinClass",0
AppName  db "Our First Window",0
OurText  db "Win32 assembly is great and easy!",0
.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
.code

_start:
        _invoke GetModuleHandle, NULL
        mov    hInstance,eax
        _invoke GetCommandLine
        _invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
        _invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	_invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	_invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	_invoke RegisterClassEx,ADDR wc
	_invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
	WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
	CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
	hInst,NULL
	mov   hwnd,eax
	_invoke ShowWindow, hwnd,SW_SHOWNORMAL
	_invoke UpdateWindow, hwnd
	.WHILE TRUE
                _invoke GetMessage,ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                _invoke TranslateMessage,ADDR msg
                _invoke DispatchMessage,ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret 16
WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	LOCAL rect:RECT
	.IF uMsg==WM_DESTROY
                _invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_PAINT
                _invoke BeginPaint,hWnd,ADDR ps
	mov    hdc,eax
                _invoke GetClientRect,hWnd,ADDR rect
                _invoke DrawText, hdc,ADDR OurText,-1,ADDR rect, DT_SINGLELINE or DT_CENTER or DT_VCENTER
                _invoke EndPaint,hWnd,ADDR ps
	.ELSE
                _invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                ret 16
	.ENDIF
	xor    eax,eax
        ret 16
WndProc ENDP
END _start
